using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixDLL.Class;

namespace PhoenixDLL.GUI
{
    /// <summary>
    /// Frame des options du calendrier
    /// </summary>
    public partial class fr_Options : Form
    {
        #region Variables
        /// <summary>
        /// Objet de proprits
        /// </summary>
        protected Options options = Options.GetInstance();
        /// <summary>
        /// Copy of the options
        /// </summary>
        private SavedOptions vSavedOptions = new SavedOptions();
        #endregion

        #region Constructeurs
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_Options()
        {
            InitializeComponent();
            pg_Properties.SelectedObject = options;
        }
        #endregion

        #region Event
        /// <summary>
        /// Evnement sur un clique sur OK
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_OK(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Close();
        }
        /// <summary>
        /// Evnement sur un clique sur Annuler
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_Cancel(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            vSavedOptions.Undo();
            this.Close();
        }
        #endregion

        #region Messages
        /// <summary>
        /// Catch the message to see if the "closing cross" was clicked
        /// </summary>
        /// <param name="m"></param>
        protected override void WndProc(ref Message m)
        {
            if (m.Msg == 0x112 && (int)m.WParam == 0xF060)
                vSavedOptions.Undo();
            base.WndProc(ref m);
        }
        #endregion

        #region Properties
        /// <summary>
        /// Gets the PropertyGrid
        /// </summary>
        public PropertyGrid PropertyGrid { get { return this.pg_Properties; } }
        #endregion
    }
}